
FindMarbleChains

;clear destruction table
	XOR A
	LD (ChainExisting),A
	LD HL,DestructionTable
	LD B,64
FindMarbleChains_Rows2
	LD (HL),A
	INC HL
	DJNZ FindMarbleChains_Rows2
	
;find chains in rows and collumns
	CALL FindMarbleChains_Rows
	CALL FindMarbleChains_Cols
	
	
	RET
ChainExisting	.BYTE 0				;0 -no chain created, 1 - yes, there are existing chains
	
	
;--------------
FindMarbleChains_Rows
;mark chains of 3 and more same marbles in rows
	LD HL,BoardData
	LD IX,DestructionTable
	
	
	LD C,8							;nr of rows
FindMarbleChains_Rows3
		
;one row
	LD B,8							;marbles in the row
	LD D,255						;nr of marble in the current chain, at the start of new row, point to nonexisting marble (nr 255)
	LD E,1							;number of repeats of marble in the chain

FindMarbleChains_Rows4
	CALL CompareTwoMarbles			;chain continuation - set zero flag, otherwise not set
	JR Z,FindMarbleChains_Rows5		;continuation - skip making new chain
	
;make new chain	
	LD A,(HL)	
	AND 00000111b					;extract color (useful for diamonds)					
	LD D,A							;current marble defines new chain
	LD E,1							;which is length 1 at the moment
	
FindMarbleChains_Rows5		
	LD A,E							;is the chain 3 elements long or more
	CP 3
	JR C,FindMarbleChains_Rows7	;no too short
	
;mark long chain	
	LD A,1							;1 - mark marbles as part of chain - ready to be destroyed
	LD (ChainExisting),A
	PUSH DE
	PUSH IX
FindMarbleChains_Rows6	
	LD (IX+0),A						;write 1 to the positions of marbles in the chain
	DEC IX
	DEC E
	JR NZ, FindMarbleChains_Rows6	;marking the chain, going from right to left	
	POP IX
	POP DE
	
FindMarbleChains_Rows7	
	INC HL							;next marble
	INC IX							;next position in destructin table
	INC E							;increase chain length
	DJNZ FindMarbleChains_Rows4
	
	DEC C
	JR NZ,FindMarbleChains_Rows3
	RET
	
	

	
;---------------------------------
FindMarbleChains_Cols
	;mark chains of 3 and more same marbles in rows
	LD HL,BoardData
	LD IX,DestructionTable			;we get table with already marked rows
									;don't clear anything and add marble chains in cols
	
	
	LD C,8							;nr of cols

FindMarbleChains_Cols3
;one collumn
	LD B,8							;marbles in the collumn
	LD D,255						;nr of marble in the current chain, at the start of new row, point to nonexisting marble (nr 255)
	LD E,1							;number of repeats of marble in the chain

FindMarbleChains_Cols4
	CALL CompareTwoMarbles			;chain continuation - set zero flag, otherwise not set
	JR Z,FindMarbleChains_Cols5		;continuation - skip making new chain
	
;make new chain	
	LD A,(HL)
	AND 00000111b					;extract color (useful for diamonds)
							
	LD D,A							;current marble color defines new chain
	LD E,1							;which is length 1 at the moment
	
FindMarbleChains_Cols5		
	LD A,E							;is the chain 3 elements long or more
	CP 3
	JR C,FindMarbleChains_Cols7	;no too short
	
;mark long chain	
	LD A,1							;1 - mark marbles as part of chain - ready to be destroyed
	LD (ChainExisting),A

	PUSH IX
	PUSH DE
FindMarbleChains_Cols6	
	LD (IX+0),A						;write 1 to the positions of marbles in the chain
	
	REPT 8	
	DEC IX							;go to one row up
	ENDR
	
	DEC E
	JR NZ, FindMarbleChains_Cols6	;marking the chain, going from right to left	
	POP DE
	POP IX
	
FindMarbleChains_Cols7
	PUSH DE
	LD DE,8	
	ADD HL,DE						;next marble (in next row)
	ADD IX,DE						;next position in destruction table
	POP DE
	
	INC E							;increase chain length
	DJNZ FindMarbleChains_Cols4		;repeat until all collumn is done
	

	
	PUSH DE							;go to top marble in next collumn
	LD DE,65536-63						;HL=HL-64 - return to to top of collumn
									;and HL=HL+1 - go one marble right to next collumn
									;so HL-64+1=HL-63
	
	ADD HL,DE						;adding 65536-N is the same as subtracting N
	ADD IX,DE						;(there is no SUB IX,DE instruction)
	
		
	POP DE
	
	DEC C
	JR NZ,FindMarbleChains_Cols3
	RET


	
;-------------	
	
CompareTwoMarbles
	LD A,D
	OR A
	JR Z,CompareTwoMarbles6			;don't build chains of empty fields
	
	LD	A,(HL)						;check marble
	AND 00000111b					;extract color (useful for diamonds)
	
	CP D							;continuation of current chain?
	JR NZ,CompareTwoMarbles6		;no, make new chain
	
	
CompareTwoMarbles5
	XOR A							;set zero flag -marbles the same
	RET
	
CompareTwoMarbles6
	LD A,1							;unset zero flag
	OR A
	RET	
	
	
	