;--------------------
Falling
;FALLING OF MARBLES IN COLLUMNS AFTER MARBLES CLEARING
;the algorithm:

; 1- CUT THE EMPTY AREAS (AFTER THE DESTRUCTION) AND CREATE FINAL COLLUMN

	;scan collumn from bottom to top
	;if  marbles -> repeat until spaces, 8 marbles=full collumn, end
	;if spaces -> go until meet marbles, only spaces up to the top -> end
	;found marble ->count spaces=N
	;scroll the marbles from top N positions down to fill the spaces
	;mark that scrolling was made
	; repeat (there maybe more holes in the collumn)until no more scrolling is made
	
; 2 - COMPARE CURRENT COLLUMN AND FINAL COLLUMN
	;scan current collumn until find marble
	;scan final collumn until find marble
	;store both screen positions for the marble
	;reapeat for all marbles
	
; 3 - MOVE
	;going from bottom of collumn move all marbles in steps until
	;current position = final position

	;do for all collumns (one step - all collumns falling)
	

;copy board data to new table
	LD HL,BoardData
	LD DE,NewBoardData
	LD BC,64
	LDIR

;count the final position that will happen after all falling
	LD HL,NewBoardData+56					;begin from bottom position in leftmost collumn
	LD B,8									;nr of collumns
Falling2
	PUSH BC
	PUSH HL
	CALL OneCollumnFalling					;check if falling, if yes -> transform the collumn
	POP HL
	POP BC
	
	INC L									;next collumn
	DJNZ Falling2							;do all collumns 
	RET	

;----------------
OneCollumnFalling
;HL-position in data table of the lowest row in the collumn
	PUSH HL

	XOR A
	LD (CollumnFalling),A					;mark at start by default that collumn is not falling
	
	LD DE,8
	EXX
	LD DE,8
	EXX
	LD C,7									;bottom row

;search for first empty space
OneCollumnFalling2
	LD A,(HL)								;check position
	OR A									;0=empty								
	JR Z,OneCollumnFalling3
	
	SUB HL,DE								;marble found at position, go to next position
	DEC C									;change row nr, go one row up
	
	LD A,C
	OR A									
	JR NZ,OneCollumnFalling2				;repeat until space is found
	JR NoFalling							;0->top row reached->no falling (collumn consists of 8 marbles)

;space found, count spaces until first marble (or top of collumn appears)
OneCollumnFalling3
	LD B,C									;B=row of most bottom space
	PUSH HL
	EXX
	POP HL									;alternate HL - position of most bottom space in the hole
	EXX
	
OneCollumnFalling4
	LD A,(HL)								;check position
	OR A									;search for	marbles, non zero values							
	JR NZ,OneCollumnFalling5
	
	SUB HL,DE								;space found at position, go to next position
	DEC C									;change row nr, go one row up
	
	LD A,C
	OR A									
	JR NZ,OneCollumnFalling4				;repeat until space is found
	JR NoFalling							;0->top row reached->no falling (row consists of marbles at bottom and space at top
											;or is empty (8 spaces)

;this code reached ->falling will happen in this collumn
;HL-position of first marble above space									
OneCollumnFalling5
	LD A,1
	LD (CollumnFalling),A					;mark that collumn is falling

	PUSH BC
	INC C									;if first falling marble is e.g. at row 3
											;then 4 rows are falling (0,1,2,3)
OneCollumnFalling6
	LD A,(HL)								;read marble nr
	SUB HL,DE								;go one position up
	
	EXX										;alternate HL-bottom hole row
	LD (HL),A								;marble goes into the hole
	SUB HL,DE
	EXX
	DEC C
	JR NZ,OneCollumnFalling6
	
	POP BC									;B-C= number of spaces in the hole
	LD A,B									;the same number of spaces will appear at the top
	SUB C									;of collumn after falling
	LD B,A									
	XOR A									;fill with 0=spaces
	ADD HL,DE								; HL  pointed to top row-8, now it points to top row
	
OneCollumnFalling7
	LD (HL),A								;write empty spaces at top of collumn
	ADD HL,DE								;one row down
	DJNZ OneCollumnFalling7
	
;falling is done, but there could be more than one hole, for example 0XX00X0X
;and we dealt just with the first hole counting from the bottom
;so repeat it all over and if there are no more holes, it will finish
	
	POP HL									;restore initial position
	JR OneCollumnFalling
	
;----
NoFalling
;no empty spaces in the collumn, no marbles falling
	POP HL									;there was PUSH at the start, so we must do POP
	XOR A
	LD (CollumnFalling),A
	RET


CollumnFalling		.BYTE 0		;mark if marbles in currently checked collumn were falling



;--------------------------------------------
FallingAnimation
;check if there are any marbles left - no marbles  don't do animation
	LD HL,NewBoardData
	LD B,64
FallingAnimation2
	LD A,(HL)
	OR A
	JR NZ,FallingAnimation3			;marble found
	INC HL
	DJNZ FallingAnimation2
	RET								;no marbles
			

FallingAnimation3
	CALL ClearPositionsTable
	CALL FillPositionsTable
	CALL PrepareMarbleNumbers
	CALL DoAnimation
		

;-------------	
;copy new data to board data
	LD HL,NewBoardData
	LD DE,BoardData
	LD BC,64
	LDIR
	CALL DrawBoard
	RET
	
	
;-----------------------------------------------------------
ClearPositionsTable
	LD HL,MarblePositionData	
	LD D,0
	LD BC,256
ClearPositionsTable2
	LD (HL),D
	DEC BC
	LD A,B
	OR C
	JR NZ,ClearPositionsTable2
	RET
	
;-----------------------------------------------------------
FillPositionsTable
;fill falling positions data table
	LD IX,MarblePositionData
	LD HL,BoardData+56				;bottom row of leftmost collumn in current positions table
	LD DE,8
	LD C,0							;collumn nr, begin from collumn 0
	
	
	EXX
	LD HL,NewBoardData+56			;the same row for final positions table
	LD DE,8
	LD C,0							;collumn in final table
	EXX
	
FillPositionsTable2		
;do one collumn	
	LD B,7							; row in the collumn, begin from bottom row
	PUSH BC
	PUSH HL
	
	EXX
	LD B,7							;row in final table
	PUSH BC
	PUSH HL
	EXX

FillPositionsTable3		
	LD A,(HL)						;is there a marble at current position?
	OR A
	JR Z,FillPositionsTable4		;no, go searching until a marble is found
	
	CALL WriteMarblePositions		;found a marble, write its current and final position
	
;go one row up in final positions table
;in final positions table marbles are one under another - no holes, so no need to search for marble
	EXX
	OR A
	SBC HL,DE						;go up, position in table = position -8
	DEC B							;go up - change row
	EXX


FillPositionsTable4					;search for next marble in the collumn
	OR A
	SBC HL,DE						;go one position up in the collumn in current positions table
	DEC B
	LD A,B
	CP 255
	JR NZ,FillPositionsTable3		;repeat until all rows 7-0 are done
	

;collumn is done, go to next collumn
	EXX								;final positions table
	POP HL
	POP BC
	INC C							;increase nr of collumn	
	INC HL							;point to bottom ro of this next collumn, one position right in table
	EXX
	
	POP HL							;current positions table
	POP BC
	INC C
	INC HL
	
	LD A,C							;do collumns 0-7
	CP 8
	JR NZ,FillPositionsTable2
	RET
	
;------------
WriteMarblePositions
	;current position
	PUSH HL							
	PUSH BC
	EXX
	PUSH HL
	PUSH BC
	EXX
	
	CALL TransformBoardCoords		;count HL screen position based on BC coordinates of marble
	LD (IX+0),L
	INC IX
	LD (IX+0),H						;write screen position
	INC IX
	
	EXX
	POP BC
	POP HL
	EXX
	POP BC
	POP HL
	
;final position
	PUSH HL							
	PUSH BC
	EXX
	PUSH HL							;working on alternate registers - coordinates in final positions table
	PUSH BC
	
	CALL TransformBoardCoords		;count HL screen position based on BC coordinates of marble
	LD (IX+0),L
	INC IX
	LD (IX+0),H						;write screen position
	INC IX
	
	POP BC
	POP HL
	EXX
	POP BC
	POP HL
	RET	

;-----------------------------------------------------------
PrepareMarbleNumbers
;when animating falling marbles we go from collumn 0 to 7 and in each collumn from bottom row to top one
;in board  table marbles are arranged in other way, so let's make a new table with comfortable marble order
;what's more, board data contains spaces and here we need mrbles only

;clear animation marble table
	LD HL,MarbleNumbers
	LD B,64
	XOR A
PrepareMarbleNumbers2
	LD (HL),A
	INC HL
	DJNZ PrepareMarbleNumbers2

;fill animation marble table	
	LD HL,BoardData+56				;collumn 0, row 7 position
	LD IX,MarbleNumbers
	LD DE,8
	
	LD C,0							;collumn
	
PrepareMarbleNumbers3
	PUSH HL
	LD B,7							;row
	
PrepareMarbleNumbers4	
	LD A,(HL)						;read marble at current position
	OR A
	JR Z,PrepareMarbleNumbers5		;don't write empty fields
	
	LD (IX+0),A						;write marble nr to animation table
	INC IX							;next marble in animation table					
	
PrepareMarbleNumbers5
	OR A
	SBC HL,DE						;go one row up in board data
	DEC B
	LD A,B
	CP 255
	JR NZ,PrepareMarbleNumbers4		;do rows 7-0
	
	POP HL							;restore position - bottom row of current collumn
	INC HL							;bottom row of next collumn right
	
	INC C
	LD A,C
	CP 8							;do collumns 0-7
	JR NZ,PrepareMarbleNumbers3	
	RET
	
	
;-----------------------------------------------------------
DoAnimation
	LD DE,MarblePositionData
	LD IX,MarbleNumbers	
	XOR A
	LD (FallingHappened),A	
	
	HALT
	HALT
	
;change positions of all marbles that have current and final positions different
	
DoAnimation3
	LD A,(DE)					;read current position of the marble
	LD L,A
	INC DE
	LD A,(DE)
	LD H,A
	INC DE
	
	OR A						
	JR Z,DoAnimation6			;H=0 - end of marbles, all marbles done in current go
	
	LD A,(DE)					;read final position of the marble
	LD C,A
	INC DE
	LD A,(DE)
	LD B,A
	INC DE

;compare current and final positions of marble
	LD A,L
	CP C
	JR NZ,DoAnimation4			;Ls are different
	LD A,H
	CP B
	JR Z,DoAnimation5			;both Hs and Ls are the same, marble is in correct position, don't animate its falling

	
;positions are different		
DoAnimation4
	LD A,1
	LD (FallingHappened),A		;mark that there are falling marbles
	
;marble is falling down	, clear top row of its sprite and redraw the marble one row down
	PUSH DE						;store index in positions table
	
	PUSH HL
	LD DE,EmptySprite
	LD BC,3*256+1				;3 chars wide, one char high
	CALL DrawSprite				;clear top row
	POP HL
	
	CALL OneCharDown			;marble falls one row down
	PUSH HL
	LD A,(IX+0)					;marble nr
	CALL DrawPiece				;draw marble nr A at position HL
	POP HL
	POP DE
	
	DEC DE						;go to current marble position in positions table
	DEC DE
	DEC DE
	DEC DE
	
	LD A,L
	LD (DE),A
	INC DE
	LD A,H						;update current position
	LD (DE),A
	INC DE
	
	INC DE						;go to next marble position in positions table
	INC DE
	
DoAnimation5
	INC IX						;go to next marble nr
	JR DoAnimation3

	
DoAnimation6
	LD A,(FallingHappened)
	OR A						;did any marble fell down in current go
	RET Z						; if it didn't -> all marbles are in correct position, finish animation
	JR DoAnimation				;in other case continue animation
	
FallingHappened					.BYTE 0