CheckLose
	LD HL,CheckLose_Counter
	INC (HL)
	LD A,(HL)
	AND 00011111b
	OR A
	RET NZ				;don't check for legal moves too often as it slows down the game


;player loses the puzzle if there are no more possible moves left
;and he didn't clear all the marbles


	
;try all marbles swaps to see if there are possible moves
;each marble can go left or right, up or down but for let's say marbles AB
;A going right or B going left gives the same result
;so we check only marbles from rows 0-6 going down (row 7 cannot go down)
;and from collumns 0-6 going right


;--------------
;check marbles going  right
	LD C,8	;row				;8 rows
	LD HL,BoardData
	
CheckLose2
	LD B,7	;7 collumns, skipping collumn 8
	
CheckLose3
	PUSH BC
	PUSH HL
	
	CALL CheckLose_SwapRight	;swap marbles
	LD A,D
	OR E					;D - first marble nr, E - second marble number
	JR Z,CheckLose4			;don't search for chains if we swapped two empty fields (nr 0)
	
	CALL FindMarbleChains
	LD A,(ChainExisting)	;is checked move legal - it destroys new marbles?
	OR A
	JR Z,CheckLose4			;no this move is impossible
	
	POP HL						;detected possible move
	POP BC						;make POPs to earlier PUSHes 
	CALL CheckLose_SwapRight	;bring back original game position and stop checking
	RET 				
	
CheckLose4	
	POP HL
	POP BC
	CALL CheckLose_SwapRight	;bring back original game position 
	
	
	
	INC HL				;go to next marble in next collumn right
	DJNZ CheckLose3		;do one row - 7 collumns
	
	INC HL				;skip marble in collumn 8 (it can't go right) and go to left side of next row
	DEC C
	JR NZ,CheckLose2	;do 8 rows

	
	
;--------------
;check marbles going  down
	
;check 7 top rows 7*8=56 board positions (marbles from bottom row cannot go down)
;no need to count rows and collumns, just do 56 positions, one after another
	LD B,56
	LD HL,BoardData

CheckLose5
	PUSH BC
	PUSH HL
	CALL CheckLose_SwapDown	;swap marbles
	LD A,D
	OR E					;D - first marble nr, E - second marble number
	JR Z,CheckLose6			;don't search for chains if we swapped two empty fields (nr 0)
	
	CALL FindMarbleChains
	LD A,(ChainExisting)	;is checked move legal - it destroys new marbles?
	OR A
	JR Z,CheckLose6			;no this move is impossible

	POP HL						;detected possible move
	POP BC						;make POPs to earlier PUSHes 
	CALL CheckLose_SwapDown		;bring back original game position and stop checking
	RET 				
	
CheckLose6
	POP HL									
	CALL CheckLose_SwapDown		;bring back original game position
	INC HL						;go to next board position
	POP BC
	DJNZ CheckLose5				;check 56 positions

;-------------
;if this code reached -> no more moves
	LD HL,16384+10
	LD DE,NoMovesTxt
	CALL TypeText
	CALL Sound2
	
CheckLose7
	CALL GetPlayerInput
	BIT 4,A
	JP NZ,GiveUpLevel2		;wait for pressing fire
	LD BC,64510
	IN A,(C)
	BIT 3,A					;or pressing R (repeat level)
	JP Z,GiveUpLevel2			
	
	JR CheckLose7			;wait until proper key is pressed
	

;---------
CheckLose_SwapRight
	LD D,(HL)			;swaping left and right marble
	INC HL
	LD E,(HL)
	LD (HL),D
	DEC HL
	LD (HL),E
	RET
	
;---------
CheckLose_SwapDown
	LD BC,8
	LD D,(HL)			;swaping left and right marble
	ADD HL,BC
	LD E,(HL)
	LD (HL),D
	OR A				;carry=0
	SBC HL,BC
	LD (HL),E
	RET	
	
	
CheckLose_Counter	.BYTE 0