GameMenu
	CALL ClearScreen
	CALL DrawCollumns
	
	LD HL,16384+231
	LD DE,Menu1Txt
	CALL TypeText
	
	LD HL,18432+74
	INC DE
	CALL TypeText
	LD HL,18432+106
	INC DE
	CALL TypeText
	LD HL,18432+138
	INC DE
	CALL TypeText
	LD HL,18432+170
	INC DE
	CALL TypeText
	
	CALL 48598			;music	
		

	
	
GameMenu2
;testing keyboard
	LD BC,63486
	IN A,(C)
		
	BIT 0,A				;choose keys
	JR Z,SetKeys
			
	BIT 1,A				;choose joystick	
	JR Z,SetJoy
	
	BIT 2,A
	JP Z,EnterPassword
			
	BIT 3,A				;start game
	JR Z,BeginGame
	JR GameMenu2
	
SetKeys
	XOR A
	LD (KeysOrJoystick),A
	CALL Sound3
	JR GameMenu2	
	
SetJoy
	LD A,1
	LD (KeysOrJoystick),A
	CALL Sound3
	JR GameMenu2
	
BeginGame
	LD A,1
	LD (LevelNr),A
	LD A,9
	LD (TrialsNr),A
	RET
			
	

;-------------
LevelIntro
	CALL ClearScreen
	
;type level nr	
	LD A,(LevelNr)
	LD B,0

LevelIntro2
	INC B
	SUB 10
	JR NC, LevelIntro2
	
	ADD A,38				;A=A+10+28, 10-> one subtraction too many was made, 28 -> position of 0 in letters table		
	DEC B					;b-number of tens,A-number of ones
	
	LD HL,LevelTxt+7		;write ones
	LD (HL),A
	
	LD A,B
	ADD A,28
	CP 28
	JR NZ,LevelIntro3
	DEC A					;dont write LEVEL 01 but LEVEL  1 - replace 0 with space
	
LevelIntro3
	DEC HL
	LD (HL),A				;write tens
	
	LD HL,18432+11			;type e.g. LEVEL 5
	LD DE,LevelTxt
	CALL TypeText
	
	LD DE,GodNames
	CALL FindName		;DE-god name address, C-nr of challenge
	
	PUSH DE
	LD DE,ChallengeNrTxt-4	;find challenge nr text
LevelIntro4
	INC DE
	INC DE
	INC DE
	INC DE
	DEC C
	JR NZ,LevelIntro4
	
	LD HL,ChallengeTxtPos-1
	LD A,(GodNr)			;find text position
LevelIntro5
	INC HL
	DEC A
	JR NZ,LevelIntro5
	LD L,(HL)
	LD H,72	

	CALL TypeText			;type challenge nr
	
	INC HL
	LD DE,ChallengeTxt		;type CHALLENGE OF
	CALL TypeText
	
	INC HL
	POP DE					;god name
	CALL TypeText
	
	LD A,(TrialsNr)
	ADD A,28
	LD (TrialsTxt+9),A
	
	LD HL,20480+134
	LD DE,TrialsTxt
	CALL TypeText
	LD HL,22528+512+134
	LD BC,20*256+1
	LD A,65
	CALL AttrBlock
	
	
	CALL Wait
	RET

;-------------------
WinItem
	
	CALL ClearScreen
	
	LD A,(GodNr)
	PUSH AF
	
;draw item
	LD HL,Items-48
	LD DE,48	
WinItem2
	ADD HL,DE
	DEC A
	JR NZ,WinItem2
	
	EX HL,DE 
	LD HL,18432+111
	LD BC,2*256+3			;size
	CALL DrawSprite			;draw item
	POP AF
	
;item color	
	PUSH AF
	LD DE,ItemColors-1		
WinItem3
	INC DE
	DEC A
	JR NZ,WinItem3
		
	LD A,(DE)
	LD BC,2*256+3			;size
	LD HL,22528+256+111
	CALL AttrBlock
	POP AF
	
;ZEUS GIVES YOU text	
	PUSH AF
	LD DE,GodNames
	CALL FindName		;DE- name address, C-nr of challenge
	POP AF
	
	LD HL,ItemTxtPos-2	;text position
WinItem4
	INC HL
	INC HL
	DEC A
	JR NZ,WinItem4		;positions for each item - two bytes
	
	PUSH HL				;store text position adddress
	LD L,(HL)
	LD H,72
	CALL TypeText		;name of god
	INC HL
	LD DE,GivesTxt
	CALL TypeText
	
	
;name of item	
	LD DE,ItemNames
	CALL FindName		;DE- name address, C-nr of challenge
	POP HL
	INC HL				;go to item position address
	LD L,(HL)
	LD H,72
	CALL TypeText

	CALL Wait
	RET	


;-------------------
Wait
	LD B,160
Wait2
	HALT
	DJNZ Wait2
	RET
	
	
;-----------
Ending
	CALL ClearScreen
	
;screen1
 	LD HL,16384+225
 	LD DE,EndText1
 	CALL TypeText
 	
 	INC DE
 	LD HL,18432+43
 	CALL TypeText
 	
 	LD HL,18432+164
 	LD DE,Items
 	LD B,5
Ending2	
 	PUSH HL
 	PUSH BC
 	LD BC,2*256+3
 	CALL DrawSprite
 	POP BC
 	POP HL
 	LD A,L
 	ADD A,5
 	LD L,A
 	DJNZ Ending2
 	
 	LD HL,22528+256+164
 	LD DE,ItemColors
 	LD B,5
Ending3	
 	PUSH HL
 	PUSH BC
 	PUSH DE
 	LD BC,2*256+3
 	LD A,(DE)
 	CALL AttrBlock
 	POP DE
 	POP BC
 	POP HL
 	
 	LD A,L
 	ADD A,5
 	LD L,A
 	INC DE
 	DJNZ Ending3
 	CALL Sound4
 	CALL Wait
 	CALL Wait
	
;screen2
	CALL ClearScreen
	LD HL,16384+227
	LD DE,EndText2
	CALL TypeText
	
	LD HL,18432+33
	INC DE
	CALL TypeText
	
	LD HL,18432+ 174
	LD DE,Girl
	LD BC,2*256+4
	CALL DrawSprite
	CALL Wait
	CALL Wait
	JP GameOver
	
;----------------
GameIntro
	CALL ClearScreen
	LD HL,16384+226
	LD DE,IntroTxt
	CALL TypeText
	
	LD HL,18432+67
	INC DE
	CALL TypeText
	
	LD HL,18432+164
	INC DE
	CALL TypeText
	
	
	CALL Wait
	RET
	