	DEVICE ZXSPECTRUM48

	ORG 33000
	


Start
	CALL ClearScreen
	LD HL,18432+102
	LD DE,CreditsTxt
	CALL TypeText
	INC DE
	LD HL,18432+161
	CALL TypeText
	INC DE
	LD HL,18432+238
	CALL TypeText
	
	CALL Wait

Start1
	DI
	LD SP,65000
	EI
	
	CALL GameMenu
	CALL GameIntro
	
	
Start2
	DI
	LD SP,65000
	EI

	
	CALL LevelIntro
	
	CALL ClearScreen
	CALL DrawCollumns
	
	CALL SetBoard
	CALL DrawBoard
	
	
;--------------------	
MainLoop
	HALT
	CALL GiveUpLevel			;check if player presses R-replay
	CALL MovePointer
	CALL CheckWin
	CALL CheckLose

	JR MainLoop

	
;-------------------
CheckWin
	LD B,64						;check all fields on the board
	LD HL,BoardData
CheckWin2
	LD A,(HL)
	OR A						;there are still marbles left ->no win
	RET NZ
	INC HL						
	DJNZ CheckWin2

;level winning screen
	CALL ClearScreen
	LD HL,18432+136
	LD DE,LevelCompletedTxt
	CALL TypeText
	
	
;check if 5 levels of one god were completed
;if so dispay screen with gift item
	LD A,(LevelNr)
	LD B,0
CheckWin3
	INC B
	SUB 5
	JR NC,CheckWin3
	ADD A,5
	OR A
	JR Z,CheckWin4				;yes completed 5,10,15,20,25 levels
	
	
	LD HL,LevelNr			;go to next level
	INC (HL)
	LD A,9
	LD (TrialsNr),A			;9 trials for next level
	
	CALL Sound4
	CALL Wait
	JP Start2
	
;--------	
CheckWin4
;giving an item and maybe end of game
;display password for next levels
	DEC B
	LD A,B
	CP 5
	JR Z,CheckWin6			;no password for last level
	
	LD HL,20480+204
	LD DE,PasswordTxt
	CALL TypeText

	LD DE,Passwords-4
CheckWin5
	INC DE					;find password address
	INC DE
	INC DE
	INC DE
	DJNZ CheckWin5
	LD HL,20480+238
	CALL TypeText			;type password
	
CheckWin6
	CALL Sound4
	CALL Wait
	CALL Wait
	CALL WinItem			;display item gift screen
	
	LD HL,LevelNr			;go to next level
	INC (HL)
	LD A,9
	LD (TrialsNr),A			;9 trials for next level
	
	LD A,(HL)
	CP 26						;victory?
	JP Z,Ending

	JP Start2

	
;--------------------
GiveUpLevel
	LD BC,64510
	IN A,(C)
	BIT 3,A						;R pressed?
	JR Z,GiveUpLevel2			;repeat level
	
	LD BC,65278
	IN A,(C)
	BIT 2,A						;X pressed?
	JP Z,Start1					;restart the game
	RET
	
GiveUpLevel2
;decrease trials here
	LD HL,TrialsNr
	DEC (HL)
	LD A,(HL)
	OR A
	JR Z,GameOver

	JP Start2					;repeat level
	
GameOver
	CALL ClearScreen
	LD HL,18432+108
	LD DE,GameOverTxt
	CALL TypeText
	CALL Wait
	JP Start1	
	
;-----------
OldPointerPos
			.BYTE 0
			.BYTE 0	

PointerPos
PointerX	.BYTE 4
PointerY	.BYTE 4

PointerColor	.BYTE 71

MarbleSelected		.BYTE 0
MarblesDestroyed	.BYTE 0		;did marbles swap destroyed any marbles: 0-no 1-yes

LevelNr		.BYTE 0
TrialsNr	.BYTE 0

GodNr		.BYTE 0

	INCLUDE <Graphics.asm>
	INCLUDE <Text.asm>
	INCLUDE <Menus.asm>
	INCLUDE <Logic.asm>
	INCLUDE <Logic2.asm>
	INCLUDE <Logic3.asm>
	INCLUDE <Logic4.asm>
	INCLUDE <Logic5.asm>
	INCLUDE <Levels.asm>
	
	ORG 48598
	INCBIN	<MarbleMusic.bin>
	
	SAVEBIN "Marbles.bin",33000,5400
	SAVESNA "Marbles.sna",Start
